Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# ChannelSwitch Class Reference

`#include <channels.h>`

Inheritance diagram for ChannelSwitch:

List of all members.

## Detailed Description

Route input to different and/or multiple channels based on channel ID.

Definition at line 48 of file channels.h.

## SIGNALS
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
virtual void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transfered signals
virtual int | GetAutoSignalPropagation () const
## ATTACHMENT
virtual bool | Attachable ()
| returns whether this object allows attachment
virtual BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
virtual const BufferedTransformation * | AttachedTransformation () const
virtual void | Detach (BufferedTransformation *newAttachment=0)
| delete the current attachment chain and replace it with newAttachment
virtual void | Attach (BufferedTransformation *newAttachment)
| add newAttachment to the end of attachment chain
## Public Member Functions
| ChannelSwitch (BufferedTransformation &destination)
| ChannelSwitch (BufferedTransformation &destination, const std::string &outChannel)
unsigned int | ChannelPut2 (const std::string &channel, const byte *begin, unsigned int length, int messageEnd, bool blocking)
unsigned int | ChannelPutModifiable2 (const std::string &channel, byte *begin, unsigned int length, int messageEnd, bool blocking)
void | ChannelInitialize (const std::string &channel, const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
bool | ChannelFlush (const std::string &channel, bool completeFlush, int propagation=-1, bool blocking=true)
bool | ChannelMessageSeriesEnd (const std::string &channel, int propagation=-1, bool blocking=true)
byte * | ChannelCreatePutSpace (const std::string &channel, unsigned int &size)
void | AddDefaultRoute (BufferedTransformation &destination)
void | RemoveDefaultRoute (BufferedTransformation &destination)
void | AddDefaultRoute (BufferedTransformation &destination, const std::string &outChannel)
void | RemoveDefaultRoute (BufferedTransformation &destination, const std::string &outChannel)
void | AddRoute (const std::string &inChannel, BufferedTransformation &destination, const std::string &outChannel)
void | RemoveRoute (const std::string &inChannel, BufferedTransformation &destination, const std::string &outChannel)
void | Initialize (const NameValuePairs &parameters, int propagation)
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
void | MessageSeriesEnd (int propagation)
byte * | CreatePutSpace (unsigned int &size)
unsigned int | Put2 (const byte *begin, unsigned int length, int messageEnd, bool blocking)
unsigned int | PutModifiable2 (byte *begin, byte *end, int messageEnd, bool blocking)
bool | ChannelPutModifiable (const std::string &channel, byte *inString, unsigned int length)
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
## Static Public Attributes
const std::string | NULL_CHANNEL
## Protected Member Functions
unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
## Static Protected Member Functions
int | DecrementPropagation (int propagation)
## Friends
class | ChannelRouteIterator

## Member Function Documentation

bool BufferedTransformation::MessageSeriesEnd | ( | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual, inherited]`

| mark end of a series of messages There should be a MessageEnd immediately before MessageSeriesEnd. Reimplemented in Filter, and Redirector. Definition at line 175 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation().

virtual unsigned int BufferedTransformation::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual, inherited]`

  | input multiple bytes that may be modified by callee for blocking or non-blocking processing Parameters:
  messageEnd | means how many filters to signal MessageEnd to, including this one
Reimplemented in FilterWithBufferedInput. Definition at line 738 of file cryptlib.h.

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 702 of file cryptlib.h.

virtual void BufferedTransformation::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

| set propagation of automatically generated and transfered signals propagation == 0 means do not automaticly generate signals Reimplemented in SourceTemplate< T >, SourceTemplate< FileStore >, SourceTemplate< RandomNumberStore >, and SourceTemplate< StringStore >. Definition at line 778 of file cryptlib.h.

unsigned long BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual, inherited]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, ByteQueue, and RandomPool. Definition at line 229 of file cryptlib.cpp. References BufferedTransformation::AttachedTransformation(), and BufferedTransformation::CopyTo(). Referenced by RandomNumberStore::AnyRetrievable(), and Integer::BERDecode().

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 318 of file cryptlib.cpp. References BufferedTransformation::AnyMessages(), and BufferedTransformation::AttachedTransformation().

virtual bool BufferedTransformation::Attachable | ( |  | ) | `[inline, virtual, inherited]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented in Filter. Definition at line 926 of file cryptlib.h. Referenced by BufferedTransformation::Attach().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 101 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following files:

- channels.h
- channels.cpp